SAXON(1)

NAME
saxon - command line XSLT 2.0 processor

SYNOPSIS

saxon [OPTION...] [-s:SOURCEFILE] [-xsl:STYLESHEET] [-o:OUTPUT] [NAME=VALUE...]

DESCRIPTION

This manual page documents briefly the saxon command. This page was written for the Debian(TM) distribution because the original program does not have a manual page. Instead, it has HTML documentation which is shipped in the "saxon-manual" package.

saxon is a command line wrapper around the Saxon-B XSLT and XQuery processor. Using saxon you can process XML documents with XSLT 2.0 stylesheets directly from the command line. Internally, saxon is a wrapper around the Java class net.sf.saxon.Transform implemented by Saxon-B.

saxon is usually invoked passing the 3 options made explicit in the above synopsis. Usually, those options correspond respectively to the input XML file to be transformed, the XSLT stylesheet describing the desired transformation, and the output file where to save the result. However, the meaning and the need of passing them is affected by a number of other options that can be specified. See the option reference below for more information.

  Parameters

At the end of the command line, a list of parameters can be given. Parameters are passed using the syntax NAME=VALUE, to specify parameters' names and values.

A parameter name prefixed with "+" (plus sign) will be interpreted as a filesystem path parameter If the path points to a single file, that file will be parsed as XML and its document node will be passed as the parameter value. If the path points to a directory, all directly contained files will be parsed as XML files, and the sequence of their document nodes will be passed as the parameter value.

A parameter name prefixed with "!" (exclamation mark) will be interpted as a output/serialization parameter. See the specifications of XQuery and XSLT 2.0 for more information on output/serialization parameters.

To pass parameters belonging to the non-null namespace, the syntax {uri}localname=value is provided.

Parameters will be visible as global variables during XSLT processing, provided they have been declared with <xsl:param>. evaluation, provided they have been declared in the query prolog. See the XSLT specification for more information on variables and their declarations.

OPTIONS

A summary of supported options is included below. Options can be passed in any order.

We first report the options which are shared by saxon and saxonq, then those specific to saxon (or which have a different semantics).

Some options are flagged as "Saxon-SA only", such options work only if Saxon-SA is installed. Note that Saxon-SA is a commercial product, as such it is not available in Debian.

  Common options

-cr:classname
    Specify a class to be used for processing collection URIs passed to the collection() function. The class must implement net.sf.saxon.CollectionURIResolver.

-dtd: {[on] | [off]}
    Enable or disable DTD validation. Default: off.

-expand: {[on] | [off]}
    When validation is enabled, expand default values in validated documents. This option enables or disables such an expansion. Default: on.

-explain [:filename]
    Display an execution plan; the output is in XML format. If filename is not given it will be displayed on standard output.

-ext: {[on] | [off]}
    Enable or disable the ability to invoke external Java functions from query files and stylesheets. Beware that enabling them is a potential security risk when processing untrusted files. Default: off.

-l: {[on] | [off]}
    Keep (when on) or throw away (when off) line numbers in tress corresponding to source documents. When kept, line numbers can be accessed using the function saxon:line-number(). Default: off.

-outval: {[recover] | [fatal]}
    When validation is required, set whether validation errors are fatal (when "fatal" is passed) or if they only trigger warnings (when "recover" is). Default: fatal.

-p: {[on] | [off]}
    Enable or disable usage of the PTreeURIResolver. Saxon-SA only.

-r:classname
    Specify a class to be used for resolving all URIs.

-repeat:N
    Repeat the transformation N times. For benchmarking purposes.

-sa
    Perform Schema-aware processing. Saxon-SA only.

-strip: {[all] | [none] | [ignorable]}
    Specify whitespace stripping policy for source documents: strip all of them ("all"), strip none of them ("none"), strip ignorable whitespace only ("ignorable"). Default: none.

-t
    Display version, timing, and other debugging information on standard error.

-tree: {[tiny] | [linked]}
    Select the implementation of the internal tree model: tiny tree model ("tiny") or linked tree model ("linked"). See the Saxon documentation for more information on the internal tree model. Default: tiny.

-T [:classname]
    Trace various aspect of the processing; an optional class name can be given to specify a user-chosen tracer. The class must implement net.sf.saxon.trace.TraceListener. The default is a system supplied tracer. This option implies -l.

-TJ
    Enable tracing of external Java method invocation. See -ext.

-u
    Force interpretation of source document names as URI. By default they are considered to be file names, unless they start with "file:" or "http:".

-val: {[strict] | [lax]}
    When validation is enabled, choose among "strict" or "lax" validation. Saxon-SA only.

-x:classname
    Specify a class to be used as SAX parser for input documents. The class must implement either org.xml.sax.Parser or org.xml.sax.XMLReader.

-xi
    Apply XInclude processing to all input documents.

-xmlversion: {[1.0] | [1.1]}
    Choose the XML version for processing input documents. "1.1" must be specified to process XML 1.1 and Namespaces 1.1 constructs. Default: 1.0.

-?
    Display a help message and exit.

  Options specific to saxon

-a
    Use the "<?xml-stylesheet ... ?>" processing instruction from the source document to find the stylesheet to be used. This option is not compatible with -xsl.

-c:filename
    Use the compiled stylesheet stored in filename. This option is not compatible with -xsl.

-im:modename
    Use modename as the initial mode used for the transformation. Qualified modes can be specified as "{uri}localname".

-it:templatename
    Use templatename as the initial named template for the transformation. When this option is used, -xsl is optional.

-m:classname
    Specify a class to be used as the receiver for messages generated by <xsl:message>. The class must implement net.sf.saxon.event.Receiver.

-o:path
    Specify the path to be used for saving generated output. Usually path points to a filename where the main result document will be saved. If not specified such a document will be written to standard output.

    Additional output documents generated using the <xsl:result-document> command uses path as the basename for the "href" attribute of the command. If -o is missing they will be saved relatively to the current working directory.

    When -s identifies a directory, also -o should identify one. All the output documents will then be written under such a directory.

-or:classname
    Specify a class to be used as the output resolver for the "href" attribute of <xsl:result-document>. The class must implement net.sf.saxon.OutputURIResolver.

-s:path
    Specify the input file or directory. This option is required unless -it has been given. If path points to a filename, that file will be parsed as an XML document and its document node will be the context item at the beginning of the transformation. The special filename "-" can be used to require reading the input document from standard input.

    If path points to a directory all files directly contained in it will be individually transformed. In such a case -o is required. -u affects the intepretation of path.

-versmsg: {[on] | [off]}
    Enable or disable the warning about using an XSLT 2.0 processor (which Saxon-B is) on stylesheets which specify version="1.0" in their root element. Default: on.

-warnings: {[silent] | [recover] | [fatal]}
    Set the policy for handling recoverable errors: "silent" for silent recovery, "recover" for recovery with warning output on standard error, "fatal" for no recovery. Default: recover.

-xsl:filename
    Specify the main XSLT stylesheet to be used for the transformation. This option is required unless -a or -c are specified. The special filename "-" can be used to require reading the sylesheet from standard input. -u affects the intepretation of filename.

-y:filename
    Specify a class to be used as SAX parser for stylesheets. The class must implement either org.xml.sax.Parser or org.xml.sax.XMLReader. See also -x.

SEE ALSO

saxonq (1), XSL Transformations (XSLT) Version 2.0 (W3C Recommendation).

This program is fully documented by the HTML documentation of Saxon, available in the "saxon-manual" package.

AUTHOR

This manual page was written by Stefano Zacchiroli <zack@debian.org> for the Debian(TM) system (but may be used by others). Permission is granted to copy, distribute and/or modify this document under the terms of the GNU General Public License, Version 3 or any later version published by the Free Software Foundation.

On Debian systems, the complete text of the GNU General Public License can be found in /usr/share/common-licenses/GPL.

COPYRIGHT
Copyright © 2008 Stefano Zacchiroli